require 'logger'

module Gummi
  class Configuration

    include Virtus.model

    attribute :hosts,              Array[String], default: :default_hosts
    attribute :logger,             Object,        default: :default_logger
    attribute :reload_connections, Boolean,       default: false
    attribute :retry_on_failure,   Boolean,       default: false
    attribute :reload_on_failure,  Boolean,       default: false
    attribute :randomize_hosts,    Boolean,       default: false

    def default_logger
      if defined?(Rails)
        Rails.logger
      else
        Logger.new(STDERR)
      end
    end

    def default_hosts
      case Gummi.env
      when "production"     then ENV['ELASTICSEARCH_URL']
      when "staging"        then ENV['ELASTICSEARCH_URL']
      when "development"    then "localhost:9200"
      when "test"           then "localhost:9200"
      end
    end
  end
end
