module Gummi
  module Rails
    module Instrumentation

      # Rails initializer class to require Elasticsearch::Rails::Instrumentation files,
      # set up Elasticsearch::Model and hook into ActionController to display Elasticsearch-related duration
      #
      # @see http://edgeguides.rubyonrails.org/active_support_instrumentation.html
      #
      class Railtie < ::Rails::Railtie
        initializer "gummi.instrumentation" do |app|
          require 'gummi/rails/instrumentation/log_subscriber'
          require 'gummi/rails/instrumentation/controller_runtime'

          ActiveSupport.on_load(:action_controller) do
            include Gummi::Rails::Instrumentation::ControllerRuntime
          end
        end
      end

    end
  end
end
